package fantasy;
/*
Copyright (C) 2012-2015 Johan Ceuppens

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import javax.swing.ImageIcon;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import java.util.Random;
import java.util.*;

/*
 * Demon Maze of the Dwarf Mountains 
 */

class DemonMaze extends Maze 
{

private Random rng;

private MazeDatabase walls48x48;
private MazeDatabase walls96x96;

public class Coord {
	private int x,y;
	public Coord(int xx, int yy) { x = xx; y = yy; }
	public int getx() { return x; }
	public int gety() { return y; }
	public void setx(int xx) { x = xx; }
	public void sety(int yy) { y = yy; }
}

protected class Wall {
	private Coord coord;
	public Wall(int xx, int yy) { coord = new Coord(xx,yy); }
}

protected class Wall48x48 extends Wall {
	public Wall48x48(int xx, int yy) {
		super(xx,yy);
	}
}

protected class Wall96x96 extends Wall {
	public Wall96x96(int xx, int yy) {
		super(xx,yy);
	}
}

public DemonMaze()
{
	super();
	rng = new Random();
}

//no overlapping walls
public Coord makeWall(int startx, int starty, int startw, int starth)
{
	int rx,ry,i = 0;
	while (true) {

		rx = rng.nextInt(startw);
		ry = rng.nextInt(starth);

		//time constraint
		/*if (i > 1000) {
			return new Coord(rx,ry);
		}*/

		if (rx < startx || ry < starty) {
			i++;
			continue;
		} else {
			return new Coord(rx,ry);
		}
	}
}

public Coord makeCollidingWall(int startx, int starty, int startw, int starth)
{
	int rx,ry,i = 0;
	while (true) {
		rx = rng.nextInt(startw);
		ry = rng.nextInt(starth);
		//time constraint
		/*if (i > 1000) {
			return new Coord(rx,ry);
		}*/
		if (rx < startx || ry < starty) {
			i++;
			continue;
		} else {
			return new Coord(rx,ry);
		}
	}
}

public boolean collide48(Coord coo, int i) {
		if ((((Coord)coo).getx() >= ((Coord)walls48x48.get(i)).getx() 
			&& 
			((Coord)coo).getx() <= ((Coord)walls48x48.get(i)).getx()+48) || 
		   (((Coord)coo).gety() >= ((Coord)walls48x48.get(i)).gety() 
			&& 
			((Coord)coo).getx() <= ((Coord)walls48x48.get(i)).gety()+48)) {
		 	return true;
			} else {
				return false;
			}
}

public boolean collide96(Coord coo, int i) {
		if ((((Coord)coo).getx() >= ((Coord)walls96x96.get(i)).getx() 
			&& 
			((Coord)coo).getx() <= ((Coord)walls96x96.get(i)).getx()+96*2) || 
		   (((Coord)coo).gety() >= ((Coord)walls96x96.get(i)).gety() 
			&& 
			((Coord)coo).getx() <= ((Coord)walls96x96.get(i)).gety()+96)) {
		 	return true;
			} else {
				return false;
			}
}

//FIXME see addwall96x96
public void addWall48x48(int startx, int starty, int startw, int starth, Coord coo, int j)
{
	int i = j;
	coo = (Coord)makeWall(startx,starty,startw,starth);
	while (i < walls48x48.size()) {
		if (!collide48(coo,i) && !collide96(coo,i)) {
			i++; continue;
		} else {
			addWall48x48(startx,starty,startw,starth,coo,i);
			break;
		}
	}
	walls48x48.put(coo);
}

public void addFixedWall48x48(int startx, int starty) {
	Coord coo = new Coord(startx,starty);
	walls48x48.put(coo);
}

public void addWall96x96(int startx, int starty, int startw, int starth, Coord coo, int j, int k)
{
	int i = j;
	coo = (Coord)makeWall(startx,starty,startw,starth);
	while (i < walls48x48.size()) {
		if (!collide48(coo,i)) {
			i++; continue;
		} else {
			addWall96x96(startx,starty,startw,starth,coo,0,0);
		
		}
	}
	i = k;
	while (i < walls96x96.size()) {
		if (!collide96(coo,i)) {
			i++; continue;
		} else {
			addWall96x96(startx,starty,startw,starth,coo,0,0);
			break;
		}
		
	}
	walls96x96.put(coo);
}

public void addNonCollideWall96x96(int startx, int starty, int startw, int starth, Coord coo)
{
	int i = 0;
	coo = (Coord)makeWall(startx,starty,startw,starth);
	while (i < walls48x48.size()) {
		if (collide48(coo,i)) {
			i = 0;	
			coo = (Coord)makeWall(startx,starty,startw,starth);
		} else {
			int j = 0;
			while (j < walls96x96.size()) {
				if (collide96(coo,i)) {
					break;	
				} else {
					j++;
				}
			}
		}
		i++;
	}
	walls96x96.put(coo);

}

public void addNonCollideWall48x48(int startx, int starty, int startw, int starth, Coord coo)
{
	int i = 0;
	coo = (Coord)makeWall(startx,starty,startw,starth);
	while (i < walls48x48.size()) {
		if (collide48(coo,i)) {
			i = 0;	
			coo = (Coord)makeWall(startx,starty,startw,starth);
		} else {
			int j = 0;
			while (j < walls96x96.size()) {
				if (collide96(coo,i)) {
					break;	
				} else {
					j++;
				}
			}
		}
		i++;
	}
	walls48x48.put(coo);

}

public void addFixedWall96x96(int startx, int starty) {
	Coord coo = new Coord(startx,starty);
	walls96x96.put(coo);
}

public Coord getWall48x48(int index) {
	return (Coord)walls48x48.get(index);
}

public Coord getWall96x96(int index) {
	return (Coord)walls96x96.get(index);
}

public void addToBuildings(Buildings buildings, Image image0, Image image00) {
	int i = 0;
	while (i < walls48x48.size()) {
		int xx = ((Coord)walls48x48.get(i)).getx();
		int yy = ((Coord)walls48x48.get(i)).gety();
		buildings.add(new Building(xx,yy,48,48,image0));
		i++;
	}
	i = 0;

	while (i < walls96x96.size()) {
		int xx = ((Coord)walls96x96.get(i)).getx();
		int yy = ((Coord)walls96x96.get(i)).gety();
		buildings.add(new Building(xx,yy,96,96,image00));
		i++;
	}
}

};
