package fantasy;
/*
Copyright (C) 2012-2015 Johan Ceuppens 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import javax.swing.ImageIcon;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import java.util.*;

class ElfPriest extends TownsFolk2 
{
private StateTextLibrary textlib = new StateTextLibrary();
private StateTextLibrary asktextlib = new StateTextLibrary();
private StateTextLibrary itemtextlib = new StateTextLibrary();
private StateTextLibrary learntextlib = new StateTextLibrary();
private StateTextLibrary learnedanotherwordtextlib = new StateTextLibrary();

private StateTextLibrary learnvarlib = new StateTextLibrary();


public ElfPriest(int startx, int starty, String language)
{
	super(startx,starty);

	direction = "down";

	addDownImage("priest-48x64-1.png");

	if (language == "Dutch" || language == "dutch") {

		textlib.addText("Ik ben de priester.");
		//set to "-1" for not popping up the learn widget
		learnvarlib.addText("-1");

		asktextlib.addText("Uw naam weze gezegend.");
		itemtextlib.addText("Mooi onderhouden zwaard.");
		learntextlib.addText("Mime betekent hemel boven de aarde.");
		learnedanotherwordtextlib.addText("Onze mensen kennen wat technologie geleerd van de dwergen.");
	} else if (language == "English" || language == "english") {

		textlib.addText("I am the priest around here.");
		learnvarlib.addText("-1");

		asktextlib.addText("Your name be blessed.");
		itemtextlib.addText("Looks like a fine sword to me.");
		learntextlib.addText("Mime means heaven on earth.");
		learnedanotherwordtextlib.addText("Our people learned from the dwarves.");
	} else {


		textlib.addText("I am the priest around here.");
		learnvarlib.addText("-1");

		asktextlib.addText("Your name be blessed.");
		itemtextlib.addText("Looks like a fine sword to me.");
		learntextlib.addText("Mime means heaven on earth.");
		learnedanotherwordtextlib.addText("Our people learned from the dwarves.");
	}
}

public String talkto()
{
	return textlib.getText();
}

public int learn()
{
	String s = learnvarlib.getText();

	int i = Integer.parseInt(s);
	return i;
}

//must be called after currentlearn > 0 in fantasy/Game.java
public void erasecurrent(int currentlearn) 
{
	//int idx = learnvarlib.getindex() - 1;
	//learnvarlib.setText(idx, "-1");//remove learn index feature
	learnvarlib.setText(currentlearn, "-1");//remove learn index feature
}

public String asktalkto()
{
	return asktextlib.getText();
}

public String asktalkto(int index)
{
	return asktextlib.getText(index);
}

public String itemtalkto()
{
	return itemtextlib.getText();
}

public String itemtalkto(int index)
{
	return itemtextlib.getText(index);
}

public String learntalkto()
{
	return learntextlib.getText();
}

public String learntalkto(int index)
{
	return learntextlib.getText(index);
}

public String learnedanotherwordtalkto()
{
	return learnedanotherwordtextlib.getText();
}

public String learnedanotherwordtalkto(int index)
{
	return learnedanotherwordtextlib.getText(index);
}

public int talktomaxindex()
{
	return textlib.getmax();
}

public int asktalktomaxindex()
{
	return asktextlib.getmax();
}

public int itemtalktomaxindex()
{
	return itemtextlib.getmax();
}

public int learntalktomaxindex()
{
	return learntextlib.getmax();
}

public int learnedanotherwordtalktomaxindex()
{
	return learnedanotherwordtextlib.getmax();
}

};
