package fantasy;
/*
Copyright (C) 2012 Johan Ceuppens 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import javax.swing.ImageIcon;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import java.util.*;

class FantasyWidgetInventorySystem extends FantasyWidget 
{
private int yoffset;
private LinkedList spells = new LinkedList();

public class InventoryItem {
	private int x,y;
	private String name;
	private Image image;
	public InventoryItem(int xx, int yy, String n, Image img) {
		x = xx;
		y = yy;
		name = n;
		image = img;
	}
	public int getx() { return x; }
	public int gety() { return y; }
	public String getName() { return name; }
	public void setname(String n) { name = n; }
	public void setx(int xx) { x = xx; }
	public void sety(int yy) { y = yy; }
	public Image getImage() { return image; }
	public void setImage(Image img) { image = img; }
}

public FantasyWidgetInventorySystem(int startx, int starty, int yoff)
{
	super(startx,starty);
	addImage("inventorywidget-1.png");

	if (yoff <= 0) yoffset = 6; else yoffset = yoff;
}

public void addInventoryItem(int xx, int yy, String n, Image img)
{
	spells.add(new InventoryItem(xx,yy,n,img));
}

public String getxy(int xx, int yy) {
	if ((xx+yy*yoffset) < spells.size())
		return "";
	return ((InventoryItem)spells.get(xx+yy*yoffset)).getName();
}
};
