package fantasy;
/*
Copyright (C) 2012-2015 Johan Ceuppens 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import javax.swing.ImageIcon;
import java.awt.Toolkit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import java.util.*;

class GargoyleGuardian extends TownsFolk2 
{
private StateTextLibrary textlib = new StateTextLibrary();
private StateTextLibrary asktextlib = new StateTextLibrary();
private StateTextLibrary itemtextlib = new StateTextLibrary();
private StateTextLibrary learntextlib = new StateTextLibrary();
private StateTextLibrary learnedanotherwordtextlib = new StateTextLibrary();

private StateTextLibrary learnvarlib = new StateTextLibrary();


public GargoyleGuardian(int startx, int starty, String language)
{
	super(startx,starty);

	direction = "down";

	addLeftImage("gargoyle-49x64.png");
	addRightImage("gargoyle-49x64.png");
	addUpImage("gargoyle-49x64.png");
	addDownImage("gargoyle-49x64.png");

	if (language == "Dutch" || language == "dutch") {

		textlib.addText("Goedenavond.");
		//set to "-1" for not popping up the learn widget
		learnvarlib.addText("-1");

		asktextlib.addText("Je bent op de vlakte van de Vampier Sadon, een vriend van de demon die je versloeg.");
		itemtextlib.addText("Ik heb niets voor jou.");
		learntextlib.addText("Alles is dood hier.");
		learnedanotherwordtextlib.addText("Archonen zoals ik zijn de enige goede machten hier.");
	} else if (language == "English" || language == "english") {

		textlib.addText("Good Evening.");
		learnvarlib.addText("-1");

		asktextlib.addText("You are in the plane of the Vampire Sadon a friend of the demon you slayed.");
		itemtextlib.addText("I do not carry anything.");
		learntextlib.addText("Everything is dead here.");
		learnedanotherwordtextlib.addText("Archons like me are the only good entities around here.");
	} else {

		textlib.addText("Good Evening.");
		learnvarlib.addText("-1");

		asktextlib.addText("You are in the plane of the Vampire Sadon a friend of the demon you slayed.");
		itemtextlib.addText("I do not carry anything.");
		learntextlib.addText("Everything is dead here.");
		learnedanotherwordtextlib.addText("Archons like me are the only good entities around here.");
	}
}

public String talkto()
{
	return textlib.getText();
}

public int learn()
{
	String s = learnvarlib.getText();

	int i = Integer.parseInt(s);
	return i;
}

//must be called after currentlearn > 0 in fantasy/Game.java
public void erasecurrent(int currentlearn) 
{
	//int idx = learnvarlib.getindex() - 1;
	//learnvarlib.setText(idx, "-1");//remove learn index feature
	learnvarlib.setText(currentlearn, "-1");//remove learn index feature
}

public String asktalkto()
{
	return asktextlib.getText();
}

public String asktalkto(int index)
{
	return asktextlib.getText(index);
}

public String itemtalkto()
{
	return itemtextlib.getText();
}

public String itemtalkto(int index)
{
	return itemtextlib.getText(index);
}

public String learntalkto()
{
	return learntextlib.getText();
}

public String learntalkto(int index)
{
	return learntextlib.getText(index);
}

public String learnedanotherwordtalkto()
{
	return learnedanotherwordtextlib.getText();
}

public String learnedanotherwordtalkto(int index)
{
	return learnedanotherwordtextlib.getText(index);
}

public int talktomaxindex()
{
	return textlib.getmax();
}

public int asktalktomaxindex()
{
	return asktextlib.getmax();
}

public int itemtalktomaxindex()
{
	return itemtextlib.getmax();
}

public int learntalktomaxindex()
{
	return learntextlib.getmax();
}

public int learnedanotherwordtalktomaxindex()
{
	return learnedanotherwordtextlib.getmax();
}

};
